#include<stdio.h>
#include<ctype.h>
#include<string.h>
#include<stdlib.h>
#include<ctype.h>

#include"common.h"

#define VERSION "0.6"
#define ERR fprintf(stderr, "gen_batch: Generovani nebylo dokonceno kvuli chybe.\n")


typedef struct seznam { char name[256];
		      struct seznam *next;
		    } SEZNAM;

FILE *out;
char hlp[261];

int main(int argc, char **argv) 
{   
    FILE *in;
    char str[256];
    int last='#';
    int len=0;
    int flag=0;
    int first_f=1;
    int line_counter=0;
    int comm_f=0;
    int i;
    int was_n=0;
    SEZNAM *first, *act, *prev;

    if (argc != 2) {
	puts("gen_batch <soubor>");
	puts("Vygeneruje html seznam odkazu vsech jmen ze <soubor>u a\nHTML sablony pro batch soubory s komentari.");
	puts("Pro spravnou funkci je nutne, aby <soubor> byl anglicky setriden (a-z).");
	puts("Na velikosti pismen v <soubor>u nezalezi.");
	puts("Odkaz je vzdy tvaru: <polozka_ze_souboru>.html");
	printf("Verze: %s\n", VERSION);
	return 0;
    }

    if ((in=fopen(argv[1], "r")) == NULL) {
	fprintf(stderr, "gen_batch: Nemohu otevrit soubor %s\n", argv[1]);
	return -1;
    }
    
    while (fgets(str, 255, in) != NULL) {
    
	line_counter++;
	
	if (str[0] == '#') continue;
	
	if (str[0] == '@') {
	    if (strlen(str) == 1) { 
		fprintf(stderr, "gen_batch error at %d: Za znakem @ musi nasledovat jmeno.\n", line_counter);
		ERR;
		return -1;
	    }
	    if (isspace(str[1])) {
	        fprintf(stderr, "gen_batch error at %d: Za znakem @ nesmi byt bily znak.\n", line_counter);
		ERR;
		return -1;
	    }
	    str[strlen(str)-1]='\0';
	    for (i=1; i<=strlen(str); i++) { /* uprava str */
		if (isspace(str[i]) && (str[i] != '\n')) { str[i-1]='\0'; break; }
		str[i-1]=str[i]; 
	    }
	    
	    /* plneni seznamu jmen pro generovani abecedniho poradi HTML kodu */
	    if ((act=(SEZNAM *) malloc(sizeof(SEZNAM))) == NULL) { /* nedostatek pameti */
		fprintf(stderr, "gen_batch error: Nedostatek pameti !!!\n");
		ERR;
		return -1;
	    }
	    if (first_f) { 
		first=act;
		first_f=0;
		prev=first;
	    }
	    act->next=NULL;
	    strcpy(act->name, str);
	    prev->next=act;
	    prev=act;  
	    
	    flag=1;
	    strcpy(hlp, str);
	    strcat(hlp, ".html");
	    if ((out=fopen(hlp, "w")) == NULL) {
		fprintf(stderr, "gen_batch: Nemohu otevrit soubor %s\n", hlp);
		ERR;
		return -1;
	    }
	    was_n=1;
	    begin_html(out, str, OTHER);
	    continue;
	}
	
	if (str[0] == '\n') {
	    if (flag) {
		fprintf(out, "</P>\n");
		end_html(out);
		if (fclose(out) == EOF) {
		    fprintf(stderr, "gen_batch: Nemohu uzavrit soubor %s\n", hlp);
		    ERR;
		    return -1;
		}
		printf("gen_batch: %s generonan OK\n", hlp);
		flag=0;
		comm_f=0;
		was_n=0;
	    }
	}
	else { /* radek s komentarem */
	    if (! was_n) { 
		fprintf(stderr, "gen_batch error at line %d: Komentar nenalezi k zadnemu @souboru\n", line_counter); 
		ERR;
		return -1; 
	    }
	    if (str[0] == '\t') {
		for (i=1; i<strlen(str); i++) str[i-1]=str[i];
		str[i-1]='\0';
		if (comm_f) fprintf(out, "</P>\n"); 
		fprintf(out, "<P>\n");
	    }
	    fprintf(out, "%s", str);
	    comm_f=1;
	}
	
    } /* while */
    
    if (fclose(in) == EOF) {
	fprintf(stderr, "gen_batch: Nemohu uzavrit soubor %s\n", argv[1]);
	ERR;
	return -1;
    }
    
    if (was_n) fprintf(stderr, "gen_batch warning: Soubor by mel byt ukoncen prazdnym radkem.\n");
    
    /* setrideni seznamu */
    act=first;
    while (act != NULL) { len++; act=act->next; } /* spocitej si delku seznamu */

    for (i=0; i<len; i++) {
	act=first;
	while (act->next != NULL) {
	    if (strcmp(act->name, act->next->name) > 0) {
		strcpy(hlp, act->name);
		strcpy(act->name, act->next->name);
		strcpy(act->next->name, hlp);
	    }
	    act=act->next;
	}
    }

    if ((out=fopen(BATCH_FILE, "w")) == NULL) {
	fprintf(stderr, "gen_batch: Nemohu otevrit soubor " BATCH_FILE "\n");
	return -1;
    }

    begin_html(out, BATCH, GEN_BATCH);

    flag=0;
    act=first;
    while (act != NULL) {
	strcpy(str, act->name);		
	if (toupper(last) != toupper(str[0])) { /* vygeneruj pismeno abecedy */
	    if (flag == 1) {
		fprintf(out, "<TR><TD align=left><BR>");
	    }
	    else { /* prvni pruchod cyklem */ 
		fprintf(out, "<TR><TD align=left>");
	    }
	    flag=1;
	    fprintf(out, "&nbsp;<FONT size=\"+2\"><B>");
	    fprintf(out, "%c", toupper(str[0]));
	    fprintf(out, "</B></TD></TR>");
	}
        fprintf(out, "<TR><TD><A href=\"%s.html\">%s</A></TD></TR>\n", str, str);
	last=toupper(str[0]);
	act=act->next;
    }

    /* uvolneni pameti */    
    act=first;
    while (act->next != NULL) {
	act=act->next;
	free((void *) first);
	first=act;
    }
    
    end_html(out);
    
    if (fclose(out) == EOF) {
	fprintf(stderr, "gen_batch: Nemohu uzavrit soubor %s\n", BATCH_FILE);
	ERR;
	return -1;
    }

    printf("gen_batch: %s generovan OK\n", BATCH_FILE);
    
    return 0;
}


