#include<stdio.h>
#include<ctype.h>
#include<string.h>
#include<stdlib.h>
#include<unistd.h>
#include<getopt.h>
#include<sys/types.h>
#include<sys/stat.h>
#include<dirent.h>
#include<fcntl.h>
#include<errno.h>

#include"common.h"
#include"errors.h"

#define VERSION "1.0beta4"

#define BUF 4096
#define SMALL_BUF 1024
#define BYTE_BUF 256
#define ARRAY_BUF 64
#define ONCE 3

#define SOUBOR "list.html"
#define BATCH "batch.txt"

#define TAB "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;"
#define FORMAT_P "<FONT size=\"+1\">"
#define FORMAT_CON "<FONT size=\"-1\">"
#define DELICI "</TD></TR></TABLE>\n<BR><TABLE border=0 width=\"100%%\" cellpadding=0>\n"
#define TABLE_INCL "<TABLE border=0 width=\"100%%\" cellpadding=0>\n"
#define IRO fprintf(out,"<BR>\n"); was_n=0; iro()
#define ERR_END fprintf(stderr, "gen_files: Generovani nebylo dokonceno kvuli chybe.\n")

#define YES 1
#define NO 0
#define ERROR -1
#define REQ 4
#define REQ_O 5
#define INCL 6
#define FUNC 7
#define COMMENTARY 20
#define FILE_END 126
#define EMPTY 127
#define CASE_S 1
#define NON_CASE_S 0


typedef struct seznam {	char name[BYTE_BUF+1];
			/* char sh_name[BYTE_BUF+1];*/
			int present; /* pouzito pro checkout -- soubor byl(YES)/nebyl(NO) jiz testovan */
				     /* u generovani napovedy (bez argumentu -c) je tento flag nepouzit */
			struct seznam *next;
			} SEZNAM;
			
typedef struct pole { 	long position; /* pozice v souboru */
		        char *str; /* nazev */
			int checked; /* v pripade funkci a include se je honota bud YES - polozka je i v macro_files
										    NO - polozka je v souboru, ale ne v macro_files
					v pripade require a require_once slouzi k rozdeleni REQ - require
											    REQ_O - require_once 
						pro obe hodnoty plati, ze jeste soubor nebyl porovnan s macro_files
				    */
			struct pole *next;
			} POLE;

typedef struct fce {	char *funkce;
		        char name[BYTE_BUF]; /*jmeno soubor, ve kterem se funkce nachazi */
		        struct fce *next;
			} FCE;

/* ********** Globalni definice ********** */

FILE *in, *out;
unsigned char str[BUF+1], pom[BUF+1], name[BUF+1];
int line_counter=0;
FCE *fce_first=NULL, *fce_act=NULL, *fce_prev=NULL, *wall=NULL, *ppp=NULL;
SEZNAM *first=NULL, *act=NULL, *prev=NULL;
char *fce_funkce;
int funkce_first=1; /* flag pro generovani seznamu funkci, je to prvni fce? */
char macros_file[BUF], output[BUF];

extern int errno;

int opt_v=0;    
int lf='\n';
int at='@';

/* *************************************** */


int search(int fr, const char *name, int case_s)
{
	char line[80+1], *lptr = line;
	int pos = lseek(fr, 0, SEEK_CUR);
	int fpos=-1, npos=0, lpos=0;
	int real=0;

	if (name == NULL) {
		fprintf(stderr, "Cannot search for empty string!\n");
		exit(-1);
	}

	if (name[0] == '\0')
		return pos;

	memset(line, '\0', 80+1);
	while (name[npos] != '\0' && (real=read(fr, (void *) lptr, 80)) > 0) {
	    lptr[real] = '\0';
	    if (case_s) { /* bude to case_sensitive */
			
		if (tolower(lptr[lpos]) != tolower(name[npos])) npos = 0;
		
		while (tolower(lptr[lpos]) != tolower(name[npos]) &&
				lpos < real) {
			++lpos;
			++pos;
		}
		if (npos == 0 && tolower(lptr[lpos]) == tolower(name[npos]))
			fpos = pos;
		while (tolower(lptr[lpos]) == tolower(name[npos]) &&
				name[npos] != '\0' && lpos < real) {
			++lpos;
			++npos;
			++pos;
		}
		if (name[npos] == '\0')
			break;
		if (fpos != -1 && lpos == real) {
			lpos = 0;
		} else if (lpos == real){
			fpos = -1;
			lpos = 0;
			npos = 0;
		} else if (fpos != -1) {
			lpos = 0;
			npos = 0;
			pos = fpos+1;
			lseek(fr, pos, SEEK_SET);
			fpos = -1;
		}
	    } /* konec pro case_sensitive */
	    else {
		if (lptr[lpos] != name[npos]) npos = 0;
		
		while ((lptr[lpos] != name[npos]) &&
				(lpos < real)) {
			++lpos;
/*
	if ((pos >= 1435) && (pos <1442) && (strcmp(name, "function") == 0)) printf("1 %c:%c,", lptr[lpos], name[npos]);
*/
			++pos;
		}
		/*
		if ((pos > 1435) && (strcmp(name, "function") == 0)) printf("9 %c:%c,", lptr[lpos],  name[npos]);
		*/
		if ((npos == 0) && (lptr[lpos] == name[npos]))
			{ fpos = pos; 
			/*
			if ((pos > 1435) && (strcmp(name, "function") == 0)) printf("2 %c:%c,", lptr[lpos], name[npos]);
		    */
		    }
		while ((lptr[lpos] == name[npos]) &&
				(name[npos] != '\0') && (lpos < real)) {
			++lpos;
	/*
			if ((pos > 1435) && (strcmp(name, "function") == 0)) printf("3 %c:%c,", lptr[lpos], name[npos]);
	*/
			++npos;
			++pos;
		}
		if (name[npos] == '\0') {
		/* 
		    if ((pos > 1435) && (strcmp(name, "function") == 0)) printf("### %c:%c,", lptr[lpos], name[npos]);
		*/
			break;
		}
		if (fpos != -1 && lpos == real) {
		/*
		    if ((pos > 1435) && (strcmp(name, "function") == 0)) printf("&&& %d+%d+%d+%d,", fpos, lpos, real, npos);
		*/
			lpos = 0;
		} else if (lpos == real){
		/*
		    if ((pos > 1435) && (strcmp(name, "function") == 0)) printf("*** %c:%c,", lptr[lpos], name[npos]);
		*/
			fpos = -1;
			lpos = 0;
			npos = 0;
		} else if (fpos != -1) {
			lpos = 0;
			npos = 0;
			pos = fpos+1;
			lseek(fr, pos, SEEK_SET);
			fpos = -1;
		}
	    }
	}
	/*
	if ((pos > 1435) && (strcmp(name, "function") == 0)) printf("3 %d:%c,", fpos, name[npos]);
	*/
	if (real == 0) fpos=-1;
	return fpos;
}

int otevri(const char *jm) /* vytvor nove generovany soubor */
{   
    if ((out=fopen(jm, "w")) == NULL) {
		fprintf(stderr, "gen_files: Nemohu vytvorit soubor %s\n", name);
		ERR_END; return -1;
    }
    
    return 0;
}

int is_newline(const char *ret)
{   int k=0;
    int len;
  
    len=strlen(ret);
 
    while ((k < len) && (isspace(ret[k]))) k++;
  
    if (k >= len) return YES;
    else return NO;  
}

/*
int cutpath2pom(const char *ret)
{   int stop, i, j;
    
    stop=strlen(ret);
    while ((ret[stop] != '/') && (stop > 0)) stop--;
    if (stop != 0) stop++;
    for (i=stop, j=0; i <= strlen(ret); i++, j++) pom[j]=ret[i];
    
    return 0;
}
    
*/
void get2pom(const char *ret, int x) /* vezmi retez ret a od znaku na pozici x ho zkopiruj do pom; vynech koncove \n */
{   /* zjednodusene tato fce oreze formatoavci znaky a mezery za argumenty*/
    int ind, k;
    
    for (ind=x, k=0; ind < strlen(ret); ind++, k++) pom[k]=ret[ind];
    pom[k-1]='\0';
    k=strlen(pom);
    k--;
    /*printf("@@@@@@@@%d\n", pom[k]);*/
    while (isspace(pom[k])) k--; 
    pom[k+1]='\0'; /* vynech posledni znak noveho radku */
}

void fc(void) /* vygeneruj HTML kof pro funkci */
{   
    fprintf(out, TAB "\n" FORMAT_P);
    fprintf(out, "<B>%s</B>&nbsp;&nbsp;<I>(function)</I></FONT><BR>\n", pom);
}

void iro(void) /* generuji odkazy */
{
    unsigned char hlp[BUF];
     
    strcpy(hlp, pom);
    strcat(hlp, ".html");
    fprintf(out, "%s\n%s<A href=\"%s\"><B>%s</B></A>&nbsp;&nbsp;", TAB, FORMAT_P, hlp, pom);
}

void con(void) /* vygeneruj kod pro pdominku a prislusny inklud */
{   
    fprintf(out, "%s\n%s&nbsp;%s</FONT><BR>", TAB, FORMAT_CON, pom);
}

int ctrl_space(char c) /* zkontroluje, je-li za formatovacim znakem mezera */
{ 
    if (c != ' ') { fprintf(stderr, NEED_SPACE, line_counter); return 0; }
    else return 1;
}

void cut_pom(void) /* oseka prebytecne mezery ke konci radku z pom */
{  
    int i;
    
    for (i=0; i<strlen(pom); i++)
	if (isspace(pom[i]) && (pom[i] != '\n')) { pom[i]='\0'; break; }
}    

int num_fce(const char *ret) /* vrati pozici, kde zacinaji argumenty parsovane funkce */
{ 
    int i=0;
    
    while ((ret[i] != '(') && (i < strlen(ret))) i++;
    
    return i+1;
}    

int add_fc(void)
{
    char *cfce;
    int is_added=0;
    int lnght;
    
    if (! funkce_first) {
	fce_act=fce_first;
	is_added=0;
	while (fce_act != NULL) { /* kontrola, jestli uz se dana fce v seznamu nevyskytuje */
	    if (strcmp(fce_act->funkce, pom) == 0) { is_added=1; break; }
	    fce_act=fce_act->next;
	}
    }

    if (! is_added) {
    	        
	if ((fce_act=(FCE *) malloc(sizeof(FCE))) == NULL) { /* nedostatek pameti */
	    fprintf(stderr, "gen_files error: Nedostatek pameti !!!\n");
	    ERR_END;
	    exit(-1);
	}
	    
	lnght=num_fce(pom);
	if ((cfce=(char *) malloc(lnght+2)) == NULL) { /* nedostatek pameti */
	    fprintf(stderr, "gen_files error: Nedostatek pameti !!!\n");
	    ERR_END;
	    exit(-1);
	}
	
	strncpy(cfce, pom, lnght);
	cfce[lnght]=')';
	cfce[lnght+1]='\0';
	
	
	if ((fce_act->funkce=(char *) malloc(lnght+2)) == NULL) { /* nedostatek pameti */
	    fprintf(stderr, "gen_files error: Nedostatek pameti !!!\n");
	    ERR_END;
	    exit(-1);
	}
	
	if (funkce_first) {
	    fce_first=fce_act;
	    funkce_first=0;
	}
	else fce_prev->next=fce_act;
	strcpy(fce_act->funkce, cfce); /* uloz jmeno funkce */
	strcpy(fce_act->name, name); /* jmeno souboru, ve kterem se fce nachazi */
/*	printf("2 %s (%s)\n", cfce, name);*/
	fce_act->next=NULL;
	fce_prev=fce_act;
		
	free((void *) cfce);
	
	funkce_first=0;
    }
    return 1;
}

void print_help(void) {
    printf("\ngen_files - generovani technicke dokumentace pro system DKF\n");
    printf("-----------------------------------------------------------\n");
    printf("\nSyntaxe:\n"
	   "gen_files [-hV] <macros_file>(s)\n"
	   "gen_files [-vf] [-o <output_file>] -c <macros_file> <file1> [<file2> ...]\n");
    printf("\nVygeneruje dokumentaci pro DKF podle souboru <macros_file>, zkontroluje\n"
	    "spravnost maker podle souboru php.\n");
    printf("\nVolby:\n");
    printf("-h  vypise tuto napovedu\n");
    printf("-f  nebude se dotazovat na prepsani puvodniho souboru s makry (neni-li zadana\n"
	   "    volba -o)\n");
    printf("-v  zapina vypis podrobnych informaci\n");
    printf("-V  vypise informace o verzi programu\n");
    printf("-c  projde soubory file1, file2, ... a zkontroluje obsahuje-li soubor\n" 
	   "    <macros_file> prislusne polozky, chybejici pak do souboru <macros_file>\n"
	   "    (nebo do souboru <output_file>) doplni (je-li zadan soubor pres volbu -o,\n"
	   "    pak se do nej zapise cely soubor <macros_file> vcetne provedenych\n"
	   "    modifikaci, soubor <macros_file> zustane nezmenen)\n\n");
}

int find(const char *ret) { 
    act=first;
    
    while ((act != NULL) && (strcmp(act->name, ret) !=0)) act=act->next;
    
    if (act == NULL) return NO;
    else if (act->present == YES) return ERROR;
	 else { act->present=1; return YES; }
}

/* fce takeincl... a takefunc... zajistuji spravny presun v souboru pro dalsi hledani search() */

/* do str ulozi nazev inkludu ze file drescriptoru descr a pozice p */
/* funkce take vraci jestli se jedna o require (REQ) nebo o reuire_once (REQ_O) */
int takeincl2str(int descr, long p) {
    char c, *point = &c;    
    int readed;
    int i=0;
    int flag=REQ;

    lseek(descr, p, SEEK_SET);
    while (((readed=read(descr, (void *) point, 1)) > 0) && (c != '"')) { if ((c == '_') && (i == 7)) flag=REQ_O; i++; }
    i=0;
    while (((readed=read(descr, (void *) point, 1)) > 0) && (c != '"')) { str[i]=c; i++; }
    str[i]='\0';
    
    return flag;
}

/* do scr ulozi nazev funkce vcetne paramatru */
int takefc2str(int descr, long p) {
    char c, *point = &c;
    int readed;
    int i=0;
    
    lseek(descr, p, SEEK_SET);
    while (((readed=read(descr, (void *) point, 1)) > 0) && (c != ' ')) {}
    while (((readed=read(descr, (void *) point, 1)) > 0) && (c != ')')) { str[i]=c; i++; }
    str[i]=')';
    str[i+1]='\0';
    
    return 0;
}

/* fce check provede kontrolu retezce ret se vsemi polozkami seznamu 
   na nejz ukazuje first */
int check(POLE *first, const char *ret, FILE *ot, int flag) {
    POLE *p_next;
    
    p_next=first;
    while (p_next != NULL) {
	/*printf("%s:%d\n", p_next->str, p_next->checked); */
	if ((strcmp(p_next->str, ret) == 0) && (p_next->checked != YES)) break; 
	/* pouze pokud se retezce shoduji, a jeste nebyl retezec kontrolovan */
	p_next=p_next->next;
	
    }
    
    if (p_next == NULL) {
	if (opt_v) printf("\t%s not found! Puting in commmentary.\n", ret);
	return COMMENTARY;
    }
    else { p_next->checked=YES;
	   return YES;
	  }
    return 0;
}

/* prida do FILE vystup polozku ret, flag urcuje, jde-li o fci, inklud, ... */
int add_to_macros(FILE *vystup, const char *ret, int flag) {
    char c='\t';
    
    if (opt_v) printf("\tAdding %s ...", ret);    
    fwrite(&c, 1, 1, vystup);
    switch (flag) {
    case INCL: c='i'; break;
    case REQ: c='r'; break;
    case REQ_O: c='o'; break;
    case FUNC: c='f'; break;
    default: fprintf(stderr, "gen_files: Unexpected fatal error add_to_macros()!\n"); exit(0);
    }
    fwrite(&c, 1, 1, vystup);
    c=' ';
    fwrite(&c, 1, 1, vystup); 
    fwrite(ret, strlen(ret), 1, vystup);
    fwrite(&lf, 1, 1, vystup);
    if (opt_v) printf(" OK\n");
    return 0;
}

/*
int present(POLE *f, const char *r) *//* je jiz retezec pritomen v poli */
/*{
    POLE *p;
    
    p=f;
    while ((p != NULL) && (strcmp(p->str, r) != 0)) p=p->next;
    
    if (p == NULL) return NO;
    else return YES;
} */

int control(const char *ret, FILE *vstup, FILE *vystup) { /* vystup je binarni soubor !!! */ 
    int fdm; /* file descriptor pro hledani */    	
    POLE *frst_include=NULL, *frst_require=NULL, *frst_function=NULL, *act, *prv;
    int new_l=0;
    long pos=0;
    int w_add=NO;
    int lf='\n';
    int hval=0, c='#';
    int comm=NO; /* jsme v kometari? */

	if ((fdm=open(ret, O_RDONLY)) == -1) { /* otevreni souboru php pro hledani */
	    fprintf(stderr, "%s", ret);
	    perror(" error1");
	    return NO;
	}
	
	/* nejdriv musim zpracovat relevantni pozice pro "include", "require" ... */
	if ((pos=search(fdm, "include", NON_CASE_S)) != -1) { /* NON_CASE_S == hledej noc case sensitive */
	    if ((frst_include=(POLE *) malloc(sizeof(POLE))) == NULL) {
		fprintf(stderr, "gen_file error: Nedostatek pameti!\n");
		exit(0);
	    }
	    frst_include->position=pos;
	    frst_include->checked=NO;
	    frst_include->next=NULL;
	    prv=frst_include;
	    act=frst_include;
	    /* dale si zapiseme jmeno souboru, ktery se v php inkluduje */
	    takeincl2str(fdm, act->position);
	    if (((act->str)=(char *) malloc(strlen(str)+1)) == NULL) {
		fprintf(stderr, "gen_file error: Nedostatek pameti!\n");
		exit(0);
	    }
	    strcpy(act->str, str);
	    /*
	    printf("i: %ld, %s\n", act->position, act->str);
	     */
	    act=act->next;
	
	    while ((pos=search(fdm, "include", NON_CASE_S)) != -1) {
		/*if (present(frst_include, str)) continue;*/
		if ((act=(POLE *) malloc(sizeof(POLE))) == NULL) {
		    fprintf(stderr, "gen_file error: Nedostatek pameti!\n");
		    exit(0);
		}
		act->position=pos;
		act->checked=NO;
		act->next=NULL;
		prv->next=act;
		prv=act;
		/* dale si zapiseme jmeno souboru, ktery se v php inkluduje */
		takeincl2str(fdm, pos);
		if (((act->str)=(char *) malloc(strlen(str)+1)) == NULL) {
		    fprintf(stderr, "gen_file error: Nedostatek pameti!\n");
		    exit(0);
		}
		strcpy(act->str, str);
		if (strcmp(act->str, "get_user.php3") == 0) printf("%d\n", act->checked);
	/*	
		printf("i: %ld, %s\n", act->position, act->str); 
	*/	
		act=act->next;
	    }	
	}
	
	/* presun se na zacatek souboru a hledej "require" */
	lseek(fdm, 0, SEEK_SET);
	
	if ((pos=search(fdm, "require", NON_CASE_S)) != -1) {
	    if ((frst_require=(POLE *) malloc(sizeof(POLE))) == NULL) {
		fprintf(stderr, "gen_file error: Nedostatek pameti!\n");
		exit(0);
	    }
	    frst_require->position=pos;
	    frst_require->next=NULL;
	    prv=frst_require;
	    act=frst_require;
	    /* dale si zapiseme jmeno souboru, ktery se v php inkluduje */
	    act->checked=takeincl2str(fdm, act->position); /* do act->checked poznacim zdali se jedna o require popr. req_once */
	    if (((act->str)=(char *) malloc(strlen(str)+1)) == NULL) {
		fprintf(stderr, "gen_file error: Nedostatek pameti!\n");
		exit(0);
	    }
	    strcpy(act->str, str);
	/*    
	    printf("%c: %ld, %s\n", ((act->checked == REQ) ? 'r' : 'o'), act->position, act->str); 
	*/    
	    act=act->next;
	    
	    while ((pos=search(fdm, "require", NON_CASE_S)) != -1) {
		if ((act=(POLE *) malloc(sizeof(POLE))) == NULL) {
		    fprintf(stderr, "gen_file error: Nedostatek pameti!\n");
		    exit(0);
		}
		act->position=pos;
		act->checked=NO;
		act->next=NULL;
		prv->next=act;
		prv=act;
		/* dale si zapiseme jmeno souboru, ktery se v php inkluduje */
		act->checked=takeincl2str(fdm, act->position);
		if (((act->str)=(char *) malloc(strlen(str)+1)) == NULL) {
		    fprintf(stderr, "gen_file error: Nedostatek pameti!\n");
		    exit(0);
		}
		strcpy(act->str, str);
        /*        	
		printf("%c: %ld, %s\n", ((act->checked == REQ) ? 'r' : 'o'), act->position, act->str); 
	*/	
		act=act->next;
	    }	
	}

	/* presun se na zacatek souboru a zpracuj "function" */
	lseek(fdm, 0, SEEK_SET);
	
	if ((pos=search(fdm, "function", NON_CASE_S)) != -1) {
/*
	    printf("pozice=%ld\n", pos);
*/
	    if ((frst_function=(POLE *) malloc(sizeof(POLE))) == NULL) {
		fprintf(stderr, "gen_file error: Nedostatek pameti!\n");
		exit(0);
	    }
	    frst_function->position=pos;
	    frst_function->checked=NO;
	    frst_function->next=NULL;
	    prv=frst_function;
	    act=frst_function;
	    /* ulozni si nazvu fukce */
	    takefc2str(fdm, act->position);
	    if (((act->str)=(char *) malloc(strlen(str)+1)) == NULL) {
		fprintf(stderr, "gen_file error: Nedostatek pameti!\n");
		exit(0);
	    }
	    strcpy(act->str, str);
	/*    
	    printf("f: %s\n", act->str);
*/
	    act=act->next;
	    
	    while ((pos=search(fdm, "function", NON_CASE_S)) != -1) {
		if ((act=(POLE *) malloc(sizeof(POLE))) == NULL) {
		    fprintf(stderr, "gen_file error: Nedostatek pameti!\n");
		    exit(0);
		}
		act->position=pos;
		act->checked=NO;
		act->next=NULL;
		prv->next=act;
		prv=act;
		takefc2str(fdm, act->position);
		if (((act->str)=(char *) malloc(strlen(str)+1)) == NULL) {
		    fprintf(stderr, "gen_file error: Nedostatek pameti!\n");
		    exit(0);
		}
		strcpy(act->str, str);
/*
		printf("f: %s\n", act->str);
*/
		act=act->next;
	    }	
	}

	/* nejdriv prechroustej hlavni komentar */
	fgets(str, BUF, vstup); line_counter++;	
	if (str[0] == 'c') {
	    do {
		 fwrite(&str, strlen(str), 1, vystup);
		 fgets(str, BUF, vstup); line_counter++;	
	    } while (! is_newline(str));
	}
	/* nyni cti <macros_file> == vstup a kontroluj zdali se polozky u daneho '@'souboru shoduji s udaji zjistenymi 
	   primo ze souboru php */
	/* fgets(str, BUF, vstup); line_counter++; */
	while ((new_l < 2) && (! feof(vstup))) {
	    if (is_newline(str)) { new_l++; if (new_l > 1) break; fwrite(&lf, 1, 1, vystup); /* comm=NO;*/ }
	    else {
		new_l=0;
		if (str[0] == '\t') {
		    get2pom(str, 3); /* do pom si zapis jmeno daneho inkludu, requiru, funkce ... */
		    
		    switch (str[1]) { /* srovnej a pripadne dopln */
		    case 'i': hval=check(frst_include, pom, vystup, INCL); comm=NO; break;
		    case 'r': hval=check(frst_require, pom, vystup, REQ); comm=NO; break;
		    case 'o': hval=check(frst_require, pom, vystup, REQ_O); comm=NO; break;
		    case 'f': hval=check(frst_function, pom, vystup, FUNC); comm=NO; break;
		    case 'p': fwrite(&str, strlen(str), 1, vystup); comm=NO; break;
		    /*****************************************************/
		    case 'c': fwrite(&str, strlen(str), 1, vystup); comm=YES; break;
		    default:
			if (comm == YES) fwrite(&str, strlen(str), 1, vystup);
			else { fprintf(stderr, "gen_files error %d: Unknown format character '%s'\n", line_counter, str/*[1]*/);
			    exit(0);}
			break;
		    }
		    if (hval == COMMENTARY) { 
		    /* pokud check dany inklud, fci, ... nenejade vraci COMMENTARY, coz znamena, ze je potreba vsechno
		       az po nasledujici fci, inklud, ... zakomentovat */
			fwrite(&c, 1, 1, vystup);
			fwrite(&str, strlen(str), 1, vystup);
			fgets(str, BUF, vstup); line_counter++;
			if ((str[0] == '\t') && (str[1] == 'p')) { /* radek s podminkou k dane fci zakomentuj take */ 
			    fwrite(&c, 1, 1, vystup);
			    fwrite(&str, strlen(str), 1, vystup); 
			    fgets(str, BUF, vstup); line_counter++; /* nacti dalsi radek */
			}      
			if ((str[0] == '\t') && (str[1] == 'c')) { /* zapoznamkuj i komentar k dane fci */
			    comm=YES;
			    while ((! is_newline(str)) && (! feof(vstup))) {
				fwrite(&c, 1, 1, vystup);
				fwrite(&str, strlen(str), 1, vystup);
				fgets(str, BUF, vstup); line_counter++;  
			    }
			    if (is_newline(str)) {
				/*if (comm == YES) */fwrite(&c, 1, 1, vystup); /* prazdny radek po konci kometare zakomentuj take */
				fwrite(&str, strlen(str), 1, vystup); /* prazdny radek ukoncuje makro */
				new_l++;
			    }
			    else { close(fdm); return FILE_END; } 
			}
			else { continue; }
		    }
		    else 
			if (hval == YES) { /* pokud je dana fce vporadku pak ji prekopiruj tak jak je na vystup */
			    fwrite(&str, strlen(str), 1, vystup);
			}
		}
		else fwrite(&str, strlen(str), 1, vystup); /* nejedna-li se o prikaz, pak jen zkopiruj radek */
	    }
	    fgets(str, BUF, vstup); line_counter++;  /* nacti dalsi radek */
	    hval=EMPTY; /* vynuluj stavovou promennou */
	} /* konec while() cyklu pro kontrolu existujiccih polozek macros file */
	
	if (comm == NO)  /* nekonci-li makro komentarem */
	/* preskoc na pozici o jeden radek vyse, kvuli to, ze bychom mohli neco pridavat dale */
	    if (fseek(vystup, -1, SEEK_CUR)) { perror("gen_files posun"); exit(-1); }
	
	
	/* nyni projdu seznamy frst_include|function|require a zjistim, ktere polozky nebyly kontrolovany
	   -- tyto polozky nejsou v <macros_file> */   
	act=frst_include;
	while (act != NULL) {
	    if (act->checked == NO) { add_to_macros(vystup, act->str, INCL); w_add=YES; }
	    act=act->next;
	}
	act=frst_require;
	while (act != NULL) {
	    if (act->checked == REQ) { add_to_macros(vystup, act->str, REQ); w_add=YES; }
	    else if (act->checked == REQ_O) { add_to_macros(vystup, act->str, REQ_O); w_add=YES; }
	    act=act->next;
	}
	act=frst_function;
	while (act != NULL) {
	    if (act->checked == NO) { add_to_macros(vystup, act->str, FUNC); w_add=YES; }
	    act=act->next;
	}
	/* zapis dva prazdne radky -- oddelovac maker */
	/*if (w_add == YES)*/  /* dva radky zapis jen jestli bylo pridano neco s checked == NO */
	    fwrite(&lf, 1, 1, vystup);
	fwrite(&lf, 1, 1, vystup); /* jinak pridej pouze jeden radek, protoze jeden byl pridan drive */

	/* uvolni pamet seznamu */
	act=frst_include;
	while (act != NULL) { prv=act; act=act->next; free((void *) (prv->str)); free((void *) prv); }
	act=frst_require;
	while (act != NULL) { prv=act; act=act->next; free((void *) (prv->str)); free((void *) prv); }
	act=frst_function;
	while (act != NULL) { prv=act; act=act->next; free((void *) (prv->str)); free((void *) prv); }
	
	close(fdm);
	
    return YES;
}
 
int add_file(FILE *vystup, const char *name) {
    long pos=0;
    char c='c';
    int fdm;

    if ((fdm=open(name, O_RDONLY)) == -1) { /* otevreni souboru php pro hledani */
	fprintf(stderr, "%s", name);
	perror(" error2");
	exit(-1);
    }
    
    fwrite(&at, 1, 1, vystup); /* zapis '@' */
    fwrite(name, strlen(name), 1, vystup);
    fwrite(&lf, 1, 1, vystup); /* newline */
    fwrite(&c, 1, 1, vystup); /* comment */
    fwrite(&lf, 1, 1, vystup); /* newline */
    fwrite(&lf, 1, 1, vystup); /* newline */
    
    while ((pos=search(fdm, "include", NON_CASE_S)) != -1) { /* NON_CASE_S == hledej non case sensitive */
	takeincl2str(fdm, pos);
	add_to_macros(vystup, str, INCL);
    }
    lseek(fdm, 0, SEEK_SET);
    while ((pos=search(fdm, "require", NON_CASE_S)) != -1) { /* NON_CASE_S == hledej non case sensitive */
	if (takeincl2str(fdm, pos) == REQ) add_to_macros(vystup, str, REQ);
	else add_to_macros(vystup, str, REQ_O);
    }
    lseek(fdm, 0, SEEK_SET);
    while ((pos=search(fdm, "function", NON_CASE_S)) != -1) { /* NON_CASE_S == hledej non case sensitive */
	takefc2str(fdm, pos);
	add_to_macros(vystup, str, FUNC);
    }
    
    fwrite(&lf, 1, 1, vystup);
    fwrite(&lf, 1, 1, vystup);
    
    close(fdm);
    
    return 0;	
}

/******************************************************************************************************/
/* -------------------------------------------------------------------------------------------------- */
/* ----------------------- MAIN --------------------------------------------------------------------- */
/******************************************************************************************************/

int main(int argc, char **argv) 
{   
    int last='#';
    int len; /* plni se delkou retezce (nacteneho radku) */
    int comm_f=0; /* flag pro obycejny komentar */
    int main_comm_f=0; /* flag pro hlavni komentar */
    int was_n=0; /* flag pro \n\n\n */
    int arg_count=1; /* citac argumentu */
    int zavinac_f=0;
    int good_cmd=0;
    int func_f=0;
    int first_f=1;
    
    int is_in_list=0;
    int i;
    int pomint;
    
    extern char *optarg; /* getopt() */
    extern int optind; /* getopt() */
    char c;
    int opt_c=0;
    int opt_f=0;
    
    if (argc == 1) { print_help(); return 0; }
    
    strcpy(output, "");
    
    while((c=getopt(argc, argv, "c:fho:vV-")) != -1) {
	switch(c) {
	    case 'h': print_help(); return 0;
	    case 'f': opt_f=1; break;
	    case 'c': strcpy(macros_file, optarg); opt_c=1; break; /* ulozim si jmeno souboru s makry */
	    case 'o': strcpy(output, optarg); break; /* pripadne si ulozim jmeno vystupniho souboru */
	    case 'v': opt_v=1; break;
	    case 'V': printf("gen_files verze " VERSION ", Vlastimil Krejcir a Petr Kovar\n"); return 0;
	}
	
    } 

/* *************************************************************************************************** */
/* ------------ cast pro kontrolu php souboru - checkout --------------------------------------------- */
/* *************************************************************************************************** */    

    
    if (opt_c == 1) {
    
	/* pripravim si vystupni soubory */
	if (strlen(output) == 0) { /* neni-li zadan vystupni soubor, bude se pracovat s TEMP souborem */   
	    if ((out=tmpfile()) == NULL) {
		perror("Temp soubor");
		return errno;
	    }
	}
	else { /* pouzij dany vystupni soubor */
	    if ((out=fopen(output, "wb+")) == NULL) {
		printf("%s", output);
		perror(" file");
		return errno;
	    }
	} 

	if (optind == argc) { /* nejsou-li vlozena jmena souboru pro kontrolu a generovani */
	    fprintf(stderr, "gen_files: Je nutne zadat jmena kontrolovanych souboru\n");
	    return -1;
	}
	
	/* pripravim si seznam a naplnim ho jmenem prvniho souboru */
	if ((first=(SEZNAM *) malloc(sizeof(SEZNAM))) == NULL) { /* nedostatek pameti */
	    fprintf(stderr, "gen_files error: Nedostatek pameti !!!\n");
	    return -1;
	}
	/*printf("'%s'", argv[optind]);*/
	/*cutpath2pom(argv[optind]);*/
	/*printf("'%s'", pom);
	return 0;*/
	strcpy(first->name, argv[optind]);
/*	strcpy(first->sh_name, pom);*/
	first->next=NULL;
	first->present=0;
	prev=first;

	
	/* nyni si ulozime jmena souboru z prikazove radky, ktere se budou zpracovavat do seznamu */
	for (arg_count=optind+1; arg_count<argc; arg_count++) {
	    if ((act=(SEZNAM *) malloc(sizeof(SEZNAM))) == NULL) { /* nedostatek pameti */
		fprintf(stderr, "gen_files error: Nedostatek pameti !!!\n");
		return -1;
	    }    
	    /*cutpath2pom(argv[arg_count]);*/
	    strcpy(act->name, argv[arg_count]);
	/*    strcpy(act->sh_name, pom);*/
	/*    printf("'%s':'%s'\n", act->name, act->sh_name);*/
	    act->next=NULL;
	    act->present=0;
	    prev->next=act;
	    prev=act;
	}
	
	/* otevreme soubor s makry */
	if ((in=fopen(macros_file, "r")) == NULL) {
	    fprintf(stderr, "\"%s\" ", macros_file);
	    perror("error3");
	    return errno;
	}

	while (fgets(str, BUF, in) != NULL) {
	    line_counter++;  
	    if (str[0] == '@') { /* narazime na polozku souboru a zpracujeme dale jeho obsah */
		get2pom(str, 1); /* uloz si jeho jmeno do pom */
		pomint=find(pom); /* zjisti chce-li jej uzivatel kontrolovat (vlozil jsmeno tohoto souboru jako argument) */
		if (pomint == ERROR) { 
		    fprintf(stderr, "gen_files error: File \"%s\" was already checked!!!\n", pom);
		    fclose(out);
		    return -1;
		}
		if (pomint == YES) { /* soubor pom je zadan na prikazove radce a je i v macros_file - nutne ho zkontrolovat */ 
		    if (opt_v) printf("Checking %s:\n", pom); 
		    /* zkopiruj hlavicku s nazvem souboru do vystupu -- zbytek kopiruje a tvori control() */
		    fwrite(&at, 1, 1, out);
		    fwrite(&pom, strlen(pom), 1, out);
		    fwrite(&lf, 1, 1, out);
		    /* control (pom -- jmeno souboru, ktery budu porovnavat se souborem maker "in"
		       a vysledky (makra, zmeny) se budou kopirovat do "out" */
		    if (control(pom, in, out)) { if (opt_v) printf("Checking OK\n\n");}
		    else { if (opt_v)  printf("Checking error\n\n"); }
		    
		}
		else {/* pomint == NO, uzivatel nechce dany soubor z macros_file kontrolovat */
		    /*  pokud pokud neni nejake makro zadano pro kontrolu (tedy je v macros_file, ale neni
			dany soubor predan jako argument ke kontrole, tak to pouze prekopiruj do vystupniho souboru
			bez kontrolovani */  
			
		    /* zapis jsmeno souboru (s @) */
		    fwrite(&at, 1, 1, out);
		    fwrite(&pom, strlen(pom), 1, out);
		    fwrite(&lf, 1, 1, out);
		    
		    if (opt_v) printf("Copying macros for file \"%s\" ...", pom);
		    
		    do {  /* prekopiruj zbytek makra */
			if (fgets(str, BUF, in) == NULL) { 
			    fprintf(stderr, "\ngen_files error at line %d: Neocekavany konec souboru!\n", line_counter);
			    return -1;
			}
			else { line_counter++; } 
			get2pom(str, 0);
			if (strlen(pom) == 0) was_n++;
			else was_n=0;
			fwrite(&pom, strlen(pom), 1, out);
			fwrite(&lf, 1, 1, out);
		    } while (was_n < 2);
			
		    was_n=0;
		    if (opt_v) printf(" OK\n");
		}
	    }
	}
	
	fclose(in);

	/* soubory v seznamu (ziskaneho z argumentu prik. radky, ktere nemaji present bit nastaven na 1 se musi
	   do vystupniho souboru maker "out" rozparsovat a doplnit */

	/* nejdriv si vytahneme soubory *.php z batch.txt, ktere jsou davkove a ty budeme ignorovat */
	if ((in=fopen(BATCH, "r")) == NULL) {
	    fprintf(stderr, "\"%s\" ", BATCH);
	    perror("error4");
	    return errno;
	}    
	while (fgets(str, BUF, in) != NULL) {
	    if (str[0] == '@') {
		get2pom(str, 1); /* do pom zapis jmeno souboru z batch.txt */ 
		/*printf("'%s'\n", pom);*/
		act=first;
		while (act != NULL) {
		    /*printf("%s\n", act->name);*/
		    if (strcmp(pom, act->name) == 0) { act->present=YES; }
		    act=act->next;
		}
	    }
	}
	fclose(in);
	
	act=first;
	while (act != NULL) {
	    if (act->present == NO) {
		if (opt_v) { 
		    printf("File %s adding ...", act->name);
		    opt_v=0;
		    add_file(out, act->name);
		    opt_v=1;
		    printf(" OK\n");
		}
		else add_file(out, act->name);
	    }
	    act=act->next;
	}
	
	/* bylo-li zapisovano do tmp souboru (out), je nutno prepsat puvodni in soubor daty z tmp */
	if (output[0] == '\0') {
	    if (! opt_f) {
		printf("Do you really want to overwrite file \"%s\" (y/n)? ", macros_file);
		c=getchar();
		if (c != 'y') { fclose(out); return 0; }
		else if (opt_v) printf("OK\n");
	    }
	    if ((in=fopen(macros_file, "wb")) == NULL) {
		fprintf(stderr, "\"%s\" ", macros_file);
		perror("error5");
		return errno;
	    }    
	    fseek(out, 0, SEEK_SET);
	    while (fread(&c, sizeof(c), 1, out)) fwrite(&c, sizeof(c), 1, in);
	    fclose(in);
	}

	fclose(out);	

	return 0;
    } /* konec podminky opt_c */
    

/* --------------------------- Check end --------------------------------------------------------- */    
/* ----------------------------------------------------------------------------------------------- */
/* *********************************************************************************************** */

/* -------- cast pro generovani souboru html za souboru s makry -----------------------------------*/

for (arg_count=optind; arg_count < argc; arg_count++) {

    if ((in=fopen(argv[arg_count], "r")) == NULL) { /* otevri soubor s makry soubor */ 
	fprintf(stderr, "gen_files: Nemohu otevrit soubor %s\n", argv[arg_count]);
	ERR_END;
	return -1;
    }
    
    i=0;
    while (fgets(str, BUF, in) != NULL) { /* cti soubor po radcich */
	line_counter++;
	len=strlen(str); /* zapamatuj si delku radku */
	
	if (len == 0) continue;
	
	if (str[0] == '#') { was_n=0; continue; } /* ignoruj radek s komentarem */
	
	if (str[0] == '@') { /* nacti jmeno a vytvor prislusny soubor, v prom. name si jmeno zapamatuj */
	    if (len == 1) { fprintf(stderr, NOT_EMPTY, line_counter); ERR_END; return -1; }
	    if (isspace(str[1])) { fprintf(stderr, NOT_SPC, line_counter); ERR_END; return -1; }
	    i++;
	    zavinac_f=1;
	    was_n=0;
	    get2pom(str, 1); /* do pom zapis retezec, ktery pujde na vystup */
	    cut_pom(); /* osekej z neho mezery */
	    strcpy(name, pom);
	    strcat(name, ".html");
	    if (otevri(name) == -1) { ERR_END; return -1; } /* vytvoreni souboru .html */
	    begin_html(out, pom, OTHER); /* vygenerovani HTML hlavicky souboru */
	    strcpy(name, pom); /* zapamatuji si jmeno */
	   
	    /* plneni seznamu jmen pro generovani abecedniho poradi HTML kodu */
	
	    if (! first_f) {
		act=first;
		is_in_list=0;
		while (act != NULL) { /* kontrola, jestli uz se dane jmeno v seznamu nevyskytuje */
		    if (strcmp(act->name, pom) == 0) { is_in_list=1; break; }
		    act=act->next;
		}
	    }
	        
	    if (! is_in_list) { /* pokud uz dany soubor neni v seznamu */
	    
		if ((act=(SEZNAM *) malloc(sizeof(SEZNAM))) == NULL) { /* nedostatek pameti */
		    fprintf(stderr, "gen_files error: Nedostatek pameti !!!\n");
		    ERR_END;
		    return -1;
		}
	    
		if (first_f) {
		    first=act;
		    first_f=0;
		}
		else prev->next=act;
		act->next=NULL;
		strcpy(act->name, pom);
		prev=act;
	    }
	    continue;
	}
	
	if (str[0] == '\t') { /* nasleduji inkludy, podminky k inkludum a komentare k inkludum */
	    
	    if (str[1] == '\n') { fprintf(stderr, NEED_CMD, line_counter); return -1; }
	    if (len < 4) { was_n=0; fprintf(stderr, NULL_ARG, line_counter); continue; }
	    if (! zavinac_f) { fprintf(stderr, NEED_NAME, line_counter); continue; } /* */
	    
	    if ((comm_f) || (main_comm_f)) { /* jestlize jsme v komentari tak jen prekopiruj s novym odstavcem */
		fprintf(out, "<BR>\n");
		fprintf(out, "%s\n", TAB);
		get2pom(str, 1);
		fprintf(out, "%s\n", pom); /* dej cely radek na vystup */
		continue;
	    }
	    
	    get2pom(str, 3); /* do pom kopiruj retezec, ktery pujde na vystup */
	    
	    switch (str[1]) {
		case 'c': /* priprav komentar */
		    if ((! good_cmd) && (! func_f)) { was_n=0; fprintf(stderr, NOT_CMD_C, line_counter); ERR_END; return -1; }
		    if (! ctrl_space(str[2])) { ERR_END; return -1; }
		    comm_f=1; /* nastav komentarovy flag */
		    good_cmd--; /* jen sniz, muze tam byt jeste podminka */
		    func_f=0;
		    fprintf(out, "%s\n%s\n", TAB, pom); /* zapis komentar */
		    break;
		case 'i': if (! ctrl_space(str[2])) { ERR_END; return -1; }
		    cut_pom();
		    IRO; 
		    good_cmd=2;
		    func_f=0;
		    fprintf(out, "<I>(include)</I></FONT>\n<BR>\n"); 
		    break;
		case 'r': 
		    if (! ctrl_space(str[2])) { ERR_END; return -1; }
		    cut_pom();
		    IRO; 
		    good_cmd=2;
		    func_f=0;
		    fprintf(out, "<I>(require)</I></FONT>\n<BR>\n"); 
		    break;
		case 'o': 
		    cut_pom();
		    if (! ctrl_space(str[2])) { ERR_END; return -1; } 
		    IRO; 
		    good_cmd=2;
		    func_f=0;
		    fprintf(out, "<I>(require_once)</I></FONT>\n<BR>\n"); 
		    break;
		case 'f': 
		    func_f=1;
		    if (! ctrl_space(str[2])) { ERR_END; return -1; } 
		    fprintf(out,"<BR>\n"); 
		    add_fc(); /* prida funkci do seznamu */
		    fc(); 
		    break; /* generovani funkce */
		case 'p':
		    if (func_f) { was_n=0; fprintf(stderr, NOT_IF, line_counter); ERR_END; return -1; } 
		    if (! good_cmd) { was_n=0; fprintf(stderr, NOT_CMD_P, line_counter); ERR_END; return -1; }
		    if (! ctrl_space(str[2])) { ERR_END; return -1; } 
		    con(); 
		    good_cmd--; /* jen sniz, muze tam byt jeste komentar */
		    break; /* generovani podminky */
		default: fprintf(stderr, UNKWN_CMD, line_counter, str[1]); ERR_END; return -1;
	    }
	    continue; /* cti dalsi radek */
	}
	
	if (is_newline(str)) {
	    if (! zavinac_f) { fprintf(stderr, WARN_NAME, line_counter); continue; } 
	/*    if ((! main_comm_f) && (! comm_f)) { fprintf(stderr, NOT_ELINE, line_counter); continue; }*/
	
	    if (comm_f) { /* konec komentare */
		comm_f=0; /* shod komentarovy flag */
		fprintf(out, "<BR>\n"); /* ukonci odstavec */
		was_n=1;
		good_cmd=0;
		continue;
	    }
	    
	    if (main_comm_f) { /* konec hlavniho komentare */
		main_comm_f=0; /* shod flag hlavniho komentare */
		fprintf(out, "<BR>\n"); /* ukonci odstavec */
		was_n=1;
		good_cmd=0;
		continue;
	    }
	    
	    if (was_n) { /* bylo-li jiz vlozeno \n */
		end_html(out); /* vygeneruj konec HTML souboru */
		if (fclose(out) == EOF) {
		    fprintf(stderr, "gen_files: Nemohu uzavrit soubor %s\n", argv[arg_count]); /* uzavri generovany soubor .html */
		    ERR_END; return -1;
		}
		if (opt_v) printf("\"%s\" vygenerovan OK\n", name);
		was_n=0;
		zavinac_f=0;
		good_cmd=0;
		continue;
	    }
	    else { was_n=1; continue;}
	}
	else { was_n=0; }
	
	if ((str[0] == 'c') && (! main_comm_f) && (! comm_f)) { /* zpracovani hlavniho komentare */
	    
	    if (! zavinac_f) { was_n=0; fprintf(stderr, NEED_NAME, line_counter); ERR_END; return -1; }    /* */
	
	    main_comm_f=1; /* nastav flag hlavniho komentare */
	    get2pom(str, 2); /* do pom zkopiruj retez, ktery pujde na vystup */
	    fprintf(out, "%s\n", TAB); /* odsad odstavec */
	    fprintf(out, "%s\n", pom); /* dej komentar na vystup */
	    continue;
	}
	else {
	    if ((zavinac_f) && (main_comm_f || comm_f)) {     /* pokud je zadano jmeno, jinak ignoruj */
		fprintf(out, "%s ", str); /* zkopiruj radek na vystup */
		continue;
	    }
	    if (! zavinac_f) { fprintf(stderr, WARN_NAME, line_counter); continue; }
	    if ((! main_comm_f) && (! comm_f)) { fprintf(stderr, NOT_TAB, line_counter); ERR_END; return -1; }
	    was_n=0;
	}
    }
} /* cyklus pres vsechny soubory */

    /* generovani seznamu funkci */
    fce_act=fce_first;
    len=0;
    if (opt_v) printf("Generovani seznamu funkci \"%s\" ...", FUNC_FILE);
    while (fce_act != NULL) { len++; fce_act=fce_act->next;  } /* spocitej si delku seznamu */

    /* vytvorim si pomocny zarazkovy vozicek wall*/
    if ((wall=(FCE *) malloc(sizeof(FCE))) == NULL) { /* nedostatek pameti */
	fprintf(stderr, "gen_files error: Nedostatek pameti !!!\n");
	ERR_END;
	exit(-1);
    }
	
    if ((wall->funkce=(char *) malloc(1)) == NULL) { /* nedostatek pameti */
	fprintf(stderr, "gen_files error: Nedostatek pameti !!!\n");
	ERR_END;
	exit(-1);
    }
	
    strcpy(wall->funkce, ""); /* uloz prazdny ret */
    wall->next=fce_first; /* nastav wall jako porvni prvek seznamu, wall bude nemenny prvni prvek */


    if (len > 1) { /* je-li seznam delsi nez 1 prvek */
	for (i=0; i<len; i++) { /* setrid seznam abecedne -- bubble sort */
	    fce_act=wall->next;
	    fce_prev=wall; /* ukazatel nastav na zarazku */
	    while (fce_act->next != NULL) {
		if (strcmp(fce_act->funkce, fce_act->next->funkce) > 0) {
		    fce_prev->next=fce_act->next;
		    fce_act->next=fce_prev->next->next;
		    fce_prev->next->next=fce_act;
		    fce_prev=fce_prev->next;
		}
		else {
		    fce_prev=fce_act;
		    fce_act=fce_act->next;
		}
	    }
	}
    } /* konec podminky pro delku */
    
    fce_first=wall->next; /* nastav spravny novy prvni prvek seznamu */
    free((void *) wall); /* uvolni pamet zarazky */
    
    if (otevri(FUNC_FILE) == -1) { ERR_END; return -1; } /* vytvoreni souboru func.html -- seznam funkci */
    begin_html(out, "Seznam funkc", GEN_FUNC);
        
    first_f=1;
    fce_act=fce_first;
    while (fce_act != NULL) {
	strcpy(str, fce_act->funkce);		
	if (toupper(last) != toupper(str[0])) { /* vygeneruj pismeno abecedy */
	    if (first_f == 1) {
		fprintf(out, "<TR><TD align=left><BR>");
	    }
	    else { /* prvni pruchod cyklem */ 
		fprintf(out, "<TR><TD align=left>");
	    }
	    first_f=1;
	    fprintf(out, "&nbsp;<FONT size=\"+2\"><B>");
	    fprintf(out, "%c", toupper(str[0]));
	    fprintf(out, "</B></TD></TR>");
	}
        fprintf(out, "<TR><TD><A href=\"%s.html\">%s</A></TD></TR>\n", fce_act->name, str);
	last=toupper(str[0]);
	fce_act=fce_act->next;
    }

     /* uvolneni pameti */    
    fce_act=fce_first;
    while (fce_act->next != NULL) {
	fce_act=fce_act->next;
	free((void *) fce_first->funkce);
	free((void *) fce_first);
	fce_first=fce_act;
    }
    
    end_html(out);
    
    if (fclose(out) == EOF) {
	fprintf(stderr, "gen_files: Nemohu uzavrit soubor %s\n", FUNC_FILE); /* uzavri generovany soubor func.html */
	ERR_END; return -1;
    }
    if (opt_v) printf(" OK\n");



    /* generovani seznamu */
    /* setrideni seznamu */
    act=first;
    len=0;
    if (opt_v) printf("Generovani seznamu souboru \"%s\" ... ", FILES_FILE);
    while (act != NULL) { len++; act=act->next; } /* spocitej si delku seznamu */

    for (i=0; i<len; i++) { /* setrid seznam bublinovkou */
	act=first;
	while (act->next != NULL) {
	    if (strcmp(act->name, act->next->name) > 0) {
		strcpy(pom, act->name);
		strcpy(act->name, act->next->name);
		strcpy(act->next->name, pom);
	    }
	    act=act->next;
	}
    }
    
    if (otevri(FILES_FILE) == -1) { ERR_END; return -1; } /* vytvoreni souboru files.html */
    begin_html(out, "Seznam soubor", GEN_FILES);

    first_f=1;
    act=first;
    while (act != NULL) {
	strcpy(str, act->name);		
	if (toupper(last) != toupper(str[0])) { /* vygeneruj pismeno abecedy */
	    if (first_f == 1) {
		fprintf(out, "<TR><TD align=left><BR>");
	    }
	    else { /* prvni pruchod cyklem */ 
		fprintf(out, "<TR><TD align=left>");
	    }
	    first_f=1;
	    fprintf(out, "&nbsp;<FONT size=\"+2\"><B>");
	    fprintf(out, "%c", toupper(str[0]));
	    fprintf(out, "</B></TD></TR>");
	}
        fprintf(out, "<TR><TD><A href=\"%s.html\">%s</A></TD></TR>\n", str, str);
	last=toupper(str[0]);
	act=act->next;
    }

    /* uvolneni pameti */    
    act=first;
    while (act->next != NULL) {
	act=act->next;
	free((void *) first);
	first=act;
    }
    
    end_html(out);
    if (fclose(out) == EOF) {
	fprintf(stderr, "gen_files: Nemohu uzavrit soubor %s\n", FILES_FILE); /* uzavri generovany soubor .html */
	ERR_END; return -1;
    }
    if (opt_v) printf(" OK\n");

    return 0;
}

