<?php
require_once("get_parent.php");
require_once("locale.php");

function dkf_index_open($mod)
{
	return dba_open(realpath("dkf_index.db"), "$mod", "qdbm");
}

function dkf_index_close($id)
{
	return dba_close($id);
}

function prepare_index ($txt)
{
	$good_chars = array("a","A","","","b","B","c","C","","","d","D","","","e","E","","","","","f","F","g","G","h","H","i","I","","","j","J","k","K","l","L","m","M","n","N","o","O","p","P","q","Q","r","R","","","s","S","","","t","T","","","u","U","","","","","v","V","w","W","x","X","y","Y","","","z","Z","","","0","1","2","3","4","5","6","7","8","9");
	$len = strlen($txt);
	$pom = "";
	$mezera = false;
	for ($i = 0; $i<$len; $i++) {
		if (in_array($txt[$i], $good_chars)) {
			if ($mezera)
				$pom .= " ";
			$pom .= $txt[$i];
			$mezera=false;
		} else {
			$mezera=true;
		}
	}
//	$pom = preg_replace("/  +/", " ", $pom);
	$pom = strtolower(trim($pom));
    $pom = strtr($pom, '', 'escrzyaieuudt');
	return $pom;
}

function naindexuj($content, $table, $col, $custom, $item, $id)
{
	if ("" . trim($content) == "") {
		return;
	}
	$pom = prepare_index($content);
	$suffix = "$table:$item:$col:$custom";

	$tok = strtok ($pom, " ");
	while($tok) {
		$key = trim($tok);
		if (dba_exists("$key", $id)) {
			$obsah = dba_fetch("$key", $id);
			if (stristr($obsah, $suffix) == false)
				$obsah .= "." . $suffix;
		} else
			$obsah = $suffix;
		dba_replace("$key", "$obsah", $id);
		$tok = strtok(" ");
	}
}

function create_custom($table, $item)
{
	$parents = "";
	switch ($table) {
		case "photos":
			$f = get_photo_folder($item);
			$c = get_folder_coll($f);
			if ($f <= 0 || $c <= 0)
				echo "$table:$item:$f:$c chyba pri hledani rodicu\n";
			else
				$parents = "$c $f";
			break;
		case "folders" :
        case "medailonek" :
			$c = get_folder_coll($item);
			if ($c <= 0)
				echo "$item:$c:nelze zjistit rodice\n";
			else
				$parents = "$c";
			break;
		case "collections":
			break;
		case "coverage":
			$res = mysql_query("select id_photo from coverage_photo where id_coverage='$item'");
			if (mysql_num_rows($res) > 0) {
				$line = mysql_fetch_row($res);
				$parents = create_custom("photos", $line[0]) . " $line[0]";
				break;
			}
			$res = mysql_query("select id_folder from coverage_folder where id_coverage='$item'");
			if (mysql_num_rows($res) > 0) {
				$line = mysql_fetch_row($res);
				$parents = create_custom("folders", $line[0]) . " $line[0]";
				break;
			}
			$res = mysql_query("select id_collection from coverage_collection where id_coverage='$item'");
			if (mysql_num_rows($res) > 0) {
				$line = mysql_fetch_row($res);
				$parents = "$line[0]";
				break;
			} else
				die("nalezen coverage, ktery nikam nepatri: $item");
			break;
		case "source":
			$res = mysql_query("select id_photo from photo_source where id_source='$item'");
			if (mysql_num_rows($res) > 0) {
				$line = mysql_fetch_row($res);
				$parents = create_custom("photos", $line[0]) . " $line[0]";
				break;
			}
			$res = mysql_query("select id_folder from folder_source where id_source='$item'");
			if (mysql_num_rows($res) > 0) {
				$line = mysql_fetch_row($res);
				$parents = create_custom("folders", $line[0]) . " $line[0]";
				break;
			}
			$res = mysql_query("select id_collection from collection_source where id_source='$item'");
			if (mysql_num_rows($res) > 0) {
				$line = mysql_fetch_row($res);
				$parents = "$line[0]";
				break;
			} else
				die("nalezen source, ktery nikam nepatri: $item");
		
			break;
		case "photo_subject" :
			$parents = create_custom("photos", $item) . " $item";
			break;
        case "folder_subject" :
			$parents = create_custom("folders", $item) . " $item";
			break;
        case "collection_subject" :
					$parents = 
						"$line[0]";
			break;
		default:
			break;
	}
	return $parents;
}

function odindexuj($content, $table, $col, $custom, $item, $id)
{
	if ("" . trim($content) == "") {
		return;
	}
	$pom = prepare_index($content);
	$suffix = "$table:$item:$col:$custom";

	$tok = strtok ($pom, " ");
	while($tok) {
		$key = trim($tok);
		if (! dba_exists("$key", $id)) {
			$tok = strtok(" ");
			continue;
		}
		$obsah = dba_fetch("$key", $id);
		if (stristr($obsah, $suffix) == false) {
			$tok = strtok(" ");
			continue;
		}
		$obsah = substr_replace($obsah, "", strpos($obsah,$suffix), strlen($suffix));
		$obsah = str_replace("..", ".", $obsah);
		$len = strlen($obsah);
		if ($obsah[$len-1] == '.')
			$obsah = substr_replace($obsah, "", $len-1, 1);
		if ($obsah[0] == '.')
			$obsah = substr_replace($obsah, "", 0, 1);
		if ($obsah != "")
			dba_replace("$key", "$obsah", $id);
		else
			dba_delete("$key", $id);
		$tok = strtok(" ");
	}

}



function mk_index($table, $id)
{
	$res = mysql_query("select * from $table;");
	while ($line = mysql_fetch_row($res)) {
		$parents = create_custom($table, $line[0]);
		switch ($table) {
			case "coverage" :
				naindexuj($line[2], $table, "place", $parents, $line[0], $id);
				naindexuj($line[3], $table, "date", $parents, $line[0], $id);
				break;
			case "source" :
				naindexuj($line[4], $table, "shellfref", $parents, $line[0], $id);
				break;
			case "photo_subject" :
			case "folder_subject" :
			case "collection_subject" :
				naindexuj($line[1], $table, "subject", $parents, $line[0], $id);
				break;
            case "medailonek" :
				naindexuj($line[1], $table, "description", $parents, $line[0], $id);
                break;
			default:
				naindexuj($line[4], $table, "title", $parents, $line[0], $id);
				naindexuj($line[9], $table, "description", $parents, $line[0], $id);
				naindexuj($line[10], $table, "identifier", $parents, $line[0], $id);
				naindexuj($line[12], $table, "user_identifier", $parents, $line[0], $id);
				break;
		}
	}

}
?>
