<?php
/* $Id: edit_folder.php3,v 1.12.2.5 2007/04/10 13:14:23 petr Exp $ */

/*
 * zajistuje editovani kolekci, slozek a fotografii
 */


require_once("auth.php3");	/* zajistuje autentifikaci a autorizaci uzivatelu */
require_once("locks.php");	/* nacte funkce pro praci se zamky na objektech */
require_once("functions.php");
require_once("get_user.php3");
require_once("properties.php");
require_once("lib/schema.php");

/*
 * pokud nema uzivatel pravo k editaci nebo smazani objektu, pak tady nema co delat
 */
if (! check_obj_rights($log_user, $coll, $folder, $photo, $EDIT_RIGHT | $DEL_RIGHT))
	die($NO_AUTHOR);
/*
 * pro pripad, ze by se snazil editovat nekdo neco, co neni
 */
if (!isset($coll) || "$coll" == "")
	die($UNKNOWN_COLL);

/*
 * pred vlastni editaci musime nastavit zamek
 */
if (! set_lock($coll, $folder, $photo)) {
	$lock = get_lock($coll, $folder, $photo);
	if (! $lock)
		die ("nepodarilo se vytvorit zamek na objektu");
	$u_query = "select * from users where id='$lock[2]'";
	$u_result = mysql_query($u_query);
	$u_line = mysql_fetch_row($u_result);
	die ("objekt ji edituje uivatel $u_line[1]");
}

require("get_folder.php3");		/* soubor nacita informace o kolekci, slozce, fotce */

/*
 * nastaveni promennych a nazvu stranky
 * vzhledem k pozici
 */
if (isset($photo) && "$photo" != "") {
	include("photo_names.php3");
	$PAGE_TITLE = "Editace fotky $fold_line[4]";
} else if ($folder) {
	require("fold_names.php3");
	$PAGE_TITLE = "Editace sloky: $fold_line[4]";
} else {
	require("coll_names.php3");
	$PAGE_TITLE = "Editace kolekce: $fold_line[4]";
}
$PAGE_ID = "edit";		/* promenna kvuli vypisu napisu editace nebo zobrazeni */
$MAIN_TITLE = $PAGE_TITLE;	/* nadpis stranky */
$is_edit=1; 			/* kvuli vypnuti navigacnich ikon */

require("start_html.php3");	/* zacatek html stranky */

/*
 * zobrazeni nahledove fotky v editaci fotografie
 * (to abychom vedeli co editujeme
 */
if (isset($photo)) {
    $img_dim = getInstanceDim( $photo, 3 );
	echo "<table id=\"edit_table\" width=\"100%\">\n";
	echo "<tr><td class=\"photo_preview\">";
    echo "<div class=\"photo_thumb\" style=\"width:" . ($img_dim[0] + 10) . "px; height:" . ($img_dim[1] + 10) . "px;margin-bottom:15px\">";
    echo "<img src=\"get_img.php3?coll=$coll&folder=$folder&photo=$photo&num=3\" width=\"$img_dim[0] height=\"$img_dim[1]\"\" />\n";
    echo "</div>";
	echo "</td><td>";
}

/*
 * ziskani informaci o vlastnikovi objektu
 */
$user_obj = user_get($fold_line[2]);
echo "$FOLD_CREATED $fold_line[5] uivatelem $user_obj->nickname<br>";

/*
 * kdo to naposledy modifikoval
 */
$user_obj = user_get($fold_line[7]);
echo "Naposledy modifikovna $fold_line[6] uivatelem " . htmlspecialchars($user_obj->nickname, $HTMLSPECIALCHARS_FLAGS, $HTMLSPECIALCHARS_ENC) . "<br>";
if (isset($photo)) {
	echo "</td></tr>";
} else {
	echo "<table id=\"edit_table\">\n";
}

/*
 ********** zacatek formulare pro zmenu udaju **********
 */
echo "<form enctype=\"multipart/form-data\" action=\"change_folder.php3\" method=\"post\">\n";
/*
 * vytvoreni casti pro nazev, identifikator, publikuje
 */
$form_folder = $fold_line;
$form_type = $fold_line[3];
include("form_folder.php3");

/*
 * policko s urovni prustupu
 * ZASTARALE !!!
 */
echo "<tr><td>rove pstupu</td>";
$form_access = $fold_line[1];
include("form_access.php3");
echo "</tr>\n";

/*
 * popis objektu
 */
echo "<tr><td>Popis</td>";
echo "<td><textarea name=\"description\">";
echo "$fold_line[9]</textarea></td></tr>";

/*
 * tlacitko pro ulozeni se bude zobrazovat jenom tomu, kdo na to ma pravo
 */
if (check_obj_rights($log_user, $coll, $folder, $photo, $EDIT_RIGHT)) {
	echo "\t<TR><TD colspan=\"2\">\n";
	echo "\t\t<input type=\"submit\" name=\"save\" value=\"Uloit zmny\">\n";
	echo "\t\t<input type=\"submit\" name=\"save_and_unlock\" value=\"Uloit a odemknout\">\n<BR><BR>\n";
	echo "\t</TD></TR>\n";
}

/*
 * policka pro nastaveni ruznych metadat objektu
 */
include("form_properties.php3");

/*
 * je nutne prenaset pozici
 */
echo "\t<input type=\"hidden\" name=\"coll\" value=$coll>";
if ($folder)
	echo "\t<input type=\"hidden\" name=\"folder\" value=$folder>";
if ($photo)
	echo "\t<input type=\"hidden\" name=\"photo\" value=$photo>";

echo "</table>\n";

/*
 ********** konec formulare **********
 */
echo "</form>\n";

/*
 * tlacitko pro smazani objektu se zobrazi jenom tomu, kdo na to ma pravo
 */
if (check_obj_rights($log_user, $coll, $folder, $photo, $DEL_RIGHT)) {
	echo "<br />\n";
	echo "<table>\n";
	echo "\t<tr>\n";
	echo "<td>";
	echo "<form action=\"del_folder.php3\" method=\"get\">\n";
	echo "\t\t<input type=\"hidden\" name=\"coll\" value=$coll>\n";
	if ($folder)
		echo "\t<input type=\"hidden\" name=\"folder\" value=$folder>";
	if ($photo)
		echo "\t<input type=\"hidden\" name=\"photo\" value=$photo>";
	echo "\t\t<input type=\"submit\" value=\"Smazat objekt\">";
	echo "</form>\n";
	echo "</td>";
	echo "</tr></table>\n";
}
echo "<br>\n";
if ($coll && $folder) {
	echo "<b>Manipulace s objektem</b><br>\n";
	echo "<table>\n";
	echo "<tr><td><em>Akce</em></td><td><em>Identifiktor</em></td></tr>\n";
	echo "<form action=\"move_folder.php\" method=\"get\">\n";
	echo "\t\t<input type=\"hidden\" name=\"coll\" value=$coll>\n";
	if ($folder)
		echo "\t<input type=\"hidden\" name=\"folder\" value=$folder>";
	if ($photo)
		echo "\t<input type=\"hidden\" name=\"photo\" value=$photo>";
	echo "\t\t<td>Pesu do</td><td><input type=\"text\" name=\"mv_to\">";
	echo "\t\t<input type=\"submit\" value=\"Pesu objekt\">";
	echo "</td></tr>\n";
	echo "<tr><td colspan=\"2\">";
	echo "<font size=\"-1\"><em>(POZOR! identifiktor pesouvanho bjektu bude zmnn tak, aby vyhovoval novmu umstn)</em></font>\n";
	echo "</td></tr>";
	echo "</form>\n";
	
	echo "<form action=\"copy_folder.php\" method=\"get\">\n";
	echo "\t\t<input type=\"hidden\" name=\"coll\" value=$coll>\n";
	if ($folder)
		echo "\t<input type=\"hidden\" name=\"folder\" value=$folder>";
	if ($photo)
		echo "\t<input type=\"hidden\" name=\"photo\" value=$photo>";
	echo "\t\t<tr><td>Kopruj do</td><td><input type=\"text\" name=\"cp_to\">";
	echo "\t\t<input type=\"submit\" value=\"Kopruj objekt\"></td>\n</tr>\n";
	echo "</form>\n";
	echo "</table>\n";
}

/*
 * Vlastnosti kolekce
 */
if ($coll && ! $folder && ! $photo) {
	if ($coll_prop) {
		$tnl = ((int)$coll_prop->tab_name_len != 0) ?
		       "value=\"" . $coll_prop->tab_name_len . "\"" :
					 "";
		$tdl = ((int)$coll_prop->tab_desc_len != 0) ?
		       "value=\"" . $coll_prop->tab_desc_len . "\"" :
					 "";
		$fdl = ((int)$coll_prop->fold_desc_len != 0) ?
		       "value=\"" . $coll_prop->fold_desc_len . "\"" :
					 "";
		$ml = ((int)$coll_prop->metadata_len != 0) ?
		       "value=\"" . $coll_prop->metadata_len . "\"" :
					 "";
	} else {
		$tnl = "";
		$tdl = "";
		$fdl = "";
        $ml  = "";
	}
	echo "<h3>Vlastnosti kolekce</h3>";
	echo "<form action=\"set_coll_prop.php\" method=\"get\">\n";
    echo "<b>Schema</b><br />";
    echo "<select name=\"schema_id\">";
    echo "<option value=\"\"></option>";
    $schs = Schema::ls();
    foreach($schs as $schema) {
        echo "<option value=\"$schema->id\"";
        if ($coll_prop->id_schema == $schema->id)
            echo " selected=\"true\"";
        echo ">$schema->name</option>";
    }
    echo "</select>";
    echo "<br /><br />";
	echo "<b>Atributy kolekce</b>";
	echo "<input type=\"hidden\" name=\"coll\" value=$coll>\n";
	echo "<table>";
	echo "<tr>";
	echo "<td>ka levho sloupce</td>";
	echo "<td><input type=\"text\" name=\"tab_name_len\" size=5 $tnl> pixel</td>";
	echo "</tr>";
	echo "<tr>";
	echo "<td>ka pravho sloupce</td>";
	echo "<td><input type=\"text\" name=\"tab_desc_len\" size=5 $tdl> pixel</td>";
	echo "</tr>";
	echo "<tr>";
	echo "<td>Zobrazit znak z popisk</td>";
	echo "<td><input type=\"text\" name=\"fold_desc_len\" size=5 $fdl> znak (defaultn 250)</td>";
	echo "</tr>";
	echo "<tr>";
	echo "<td>Rozbalovat metadata pi</td>";
	echo "<td><input type=\"text\" name=\"metadata_len\" size=5 $ml> znacch (defaultn 500)</td>";
	echo "</tr>";
	echo "</table>\n";
	echo "<input type=\"hidden\" name=\"id_photo\" value=\"$coll_prop->id_photo\">";
	echo "<input type=\"submit\" value=\"Nastavit vlastnosti\">";
	echo "</form>\n";
}

/*
 * konec html vystupu
 */
include("end_html.php3");
?>
