<?php
/* $Id: rights.php,v 1.13.2.4 2007/03/14 15:38:58 petr Exp $ */

/*
 * v souboru se nastavuji globalni konstanty
 * jako nazvy moznych prav a dale poskytuje
 * funkce k overovani prav
 */

$READ_RIGHT = 1;
$EDIT_RIGHT = 2;
$ADD_RIGHT = 4;
$DEL_RIGHT = 8;
$ADD_USR_OBJ_RIGHT = $ADD_USR_GRP_RIGHT = 16;
$EDIT_USR_OBJ_RIGHT = $EDIT_USR_GRP_RIGHT = 32;
$DEL_USR_OBJ_RIGHT = $DEL_USR_GRP_RIGHT = 64;
$EDIT_GRP_RIGHT = 128;
$DEL_GRP_RIGHT = 256;
$ARCHIV_RIGHT = 512;

$ALL_ADMIN_GRP = $ADD_USR_GRP_RIGHT | $EDIT_USR_GRP_RIGHT | $DEL_USR_GRP_RIGHT | $EDIT_GRP_RIGHT | $DEL_GRP_RIGHT;
$ALL_ADMIN_OBJ = $ADD_USR_OBJ_RIGHT | $EDIT_USR_OBJ_RIGHT | $DEL_USR_OBJ_RIGHT;


class RightsCache {
	var $ip_cll;
	var $ip_fld;
	var $ip_pht;

	var $order_cll;
	var $order_fld;
	var $order_pht;

	var $usr_cll;
	var $usr_fld;
	var $usr_pht;

	var $grp_cll;
	var $grp_fld;
	var $grp_pht;

	var $usr_grp;

	var $_users;	/* loaded table for users */

	function RightsCache ()
	{
		$this->ip_cll = NULL;
		$this->ip_fld = NULL;
		$this->ip_pht = NULL;

		$this->order_cll = NULL;
		$this->order_fld = NULL;
		$this->order_pht = NULL;

		$this->usr_cll = NULL;
		$this->usr_fld = NULL;
		$this->usr_pht = NULL;
	
		$this->grp_cll = NULL;
		$this->grp_fld = NULL;
		$this->grp_pht = NULL;

		$this->usr_grp = NULL;

		$this->_users = NULL;
	}

	function _load_table ($typ, $user, $table, &$cache)
	{
		if ("$typ" == "user") {
			$query = "select id_$table, rights from user_${table}_rights where id_user=$user";
		//if ($table == 'collection')	loguj($query);
		}
		elseif ("$typ" == "group")
			$query = "select group_${table}_rights.* from user_group_rights, group_${table}_rights where user_group_rights.id_user=$user and user_group_rights.id_group=group_${table}_rights.id_group";
		elseif ("$typ" == "ip") { 
			$query = "select id_$table, mask from ip_${table}_rights where (ip&mask)=($user&mask)";
			/*
			$fp = fopen('/data/dkf/www/ip.log', 'a+');
		//fwrite($fp, var_export($this->ip_cll, true));
		fwrite($fp, "$query\n\n");
		fclose($fp);
			 */

		}
		elseif ("$typ" == "order")
			$query = "select * from ip_${table}_order"; 
		elseif ("$typ" == "ug")
			$query = "select id_group, rights from user_group_rights where id_user=$user";

		$result = mysql_query($query);
		if (! $result)
			die("Nejde nacist cache s pravama uzivatele: $query\n");
		while ($line = mysql_fetch_row($result)) {
			if ("$typ" == "group")
				$cache["$line[0]"]["$line[1]"] = $line[2];
			else
				$cache["$line[0]"] = $line[1];
		}
	}

	function load ($user)
	{
		global $REMOTE_ADDR;


		if ($this->_users && $this->_users["$user"])
			return 1;

		$this->_load_table("user", $user, "collection", $this->usr_cll);
		$this->_load_table("user", $user, "folder", $this->usr_fld);
		$this->_load_table("user", $user, "photo", $this->usr_pht);

		$this->_load_table("group", $user, "collection", $this->grp_cll);
		$this->_load_table("group", $user, "folder", $this->grp_fld);
		$this->_load_table("group", $user, "photo", $this->grp_pht);

		$this->_load_table("ug", $user, "", $this->usr_grp);

		$ip_int = ip2long($REMOTE_ADDR);

		$this->_load_table("ip", $ip_int, "collection", $this->ip_cll);
		$this->_load_table("ip", $ip_int, "folder", $this->ip_fld);
		$this->_load_table("ip", $ip_int, "photo", $this->ip_pht);

		/*
		$fp = fopen('/data/dkf/www/ip.log', 'a+');
		fwrite($fp, var_export($this->ip_cll, true));
		fwrite($fp, "\n\n");
		fclose($fp);

		 */

		$this->_load_table("order", 0, "collection", $this->order_cll);
		$this->_load_table("order", 0, "folder", $this->order_fld);
		$this->_load_table("order", 0, "photo", $this->order_pht);

		$this->_users["$user"] = 1;
	}

	function _check_rights (&$ipc, &$orderc, &$usrc, &$grpc, $id, $mask)
	{
		/*
		 * test ip adresy testuje jenom jestli mame vubec pravo na
		 * dalsi testovani jinak zamitne
		 ***
		 * Zastarale, pro otestovani ip pouzivat pred volanim teto funkce funkci
		 * _check_ip, ktera zaruci spravne dedeni
		 ***
		 */
/*		if (isset($ipc["$id"])) {
			if (! isset($orderc["$id"]) || $orderc["$id"] == 2)
				return 0;
		} */

		/*
		 * otestujem jestli nema primo uzivatel nastaveny prava na objektu
		 */
		if (isset($usrc["$id"])) {
//			if ($id == 29) {
//				loguj($id . " + " . $mask . " # " . $usrc["$id"] . " & " . (($usrc["$id"] & $mask) ? "1" : "0"));
//			}
			return (($usrc["$id"] & $mask) ? 1 : 0);
		}
		/*
		 * otestujem jestli nema skupina ve ktere je uzivatel nastavena prava
		 */
		$grret = -1;
		if ($this->usr_grp) foreach ($this->usr_grp as $key => $value) {
			if (($value & $mask) && isset($grpc["$key"]["$id"]))
				if ($grret = ($grpc["$key"]["$id"] & $mask) ? 1 : 0)
					return 1;
		}
		if ($grret != -1)
			return $grret;

		return -1;
	}

	/*
	 * kontroluje nastaveni ip
	 */
	function _check_ip_rights (&$ipc, &$orderc, $id)
	{
		$ret = -1;

		/* je defaultne zakazano mimo vybranych? */
		if ($orderc["$id"] == 1)
			$ret = 0;

		/* pokud je uzivatelova ip na seznamu */
		if (isset($ipc["$id"])) {
			/* a pokud se rika ze je defaultne povoleno krome seznamu, tak zakaz */
			if (! isset($orderc["$id"]) || $orderc["$id"] == 2)
				$ret = 0;
			/* jinak jsme na seznamu, ale protoze defaultne povoleno, tak zakazem */
			else
				$ret = 1;
		}


		return $ret;
	}

	/*
	 * zajistuje dedeni nastaveni ip z vyssich slozek
	 */
	function _check_ip($coll, $fold, $photo)
	{
		$ret = -1;


		if ($photo) {
			$ret = $this->_check_ip_rights($this->ip_pht, $this->order_pht, $photo);
		}
		if (($ret == -1) && $fold) {
			$ret = $this->_check_ip_rights($this->ip_fld, $this->order_fld, $fold);
		}
		if (($ret == -1) && $coll) {
			$ret = $this->_check_ip_rights($this->ip_cll, $this->order_cll, $coll);
		}


		
		return $ret;
	}

	function check ($coll, $fold, $photo, $mask)
	{
	  global $log_user, $anonym;
		$ret = -1;

		/*
		 * Prve overime ip adresu, ale pouze pro anonyma
		 */
		if ($log_user == $anonym) {
			$ret = $this->_check_ip($coll, $fold, $photo);

			if ($ret == 0)
				return $ret;
		}


		if ($photo) {
			$ret = $this->_check_rights($this->ip_pht,
						    $this->order_pht,
						    $this->usr_pht,
						    $this->grp_pht,
						    $photo, $mask);
			if ($ret >= 0)
				return $ret;
		}
		if ($fold) {
			$ret = $this->_check_rights($this->ip_fld,
						    $this->order_fld,
						    $this->usr_fld,
						    $this->grp_fld,
						    $fold, $mask);
			if ($ret >= 0)
				return $ret;
		}
		if ($coll) {
			//if ($coll == 29) loguj(log_user . ":\n". $str);
			$ret = $this->_check_rights($this->ip_cll,
						    $this->order_cll,
						    $this->usr_cll,
						    $this->grp_cll,
						    $coll, $mask);
			if ($ret >= 0)
				return $ret;
		}

		return $ret;
	}

	function check_group ($group, $mask)
	{
		if ($this->usr_grp["$group"] & $mask)
			return 1;

		return 0;
	}
}

$rights_cache = new RightsCache();
$anon_rights_cache = new RightsCache();


/*
 * zkratka pro check_rights, nazvy tabulek doplnuje na zaklade aktualni pozice
 */
function check_obj_rights($user, $coll, $folder, $photo, $mask, $force=false)
{
	global $rights_cache, $anon_rights_cache, $log_user, $anonym;

	/*
	 * pokud je uzivatel administrator
	 * tak ma automaticky pristup
	 */
	if (!$force && author(4))
		return 1;

	/*
	 * prvne proverime prava daneho uzivatele (pokud se nejedna o anonyma)
	 */
	if (($log_user != $anonym) &&
	    (($ret = $rights_cache->check($coll, $folder, $photo, $mask)) >= 0))
		return $ret;


	/*
	 * proverime prava anonyma
	 */
	if (($ret = $anon_rights_cache->check($coll, $folder, $photo, $mask)) >= 0)
		return $ret;

	return 0;
}

function check_grp_rights($group, $mask)
{
	global $rights_cache, $anon_rights_cache, $log_user, $anonym;

	if (author(4))
		return 1;

	/*
	 * anonym nemuze editovat prava skupin
	 */
	if ($log_user == $anonym)
		return 0;
	
	if ($rights_cache->check_group($group, $mask))
		return 1;
	
	return 0;
}


function check_cache($cache)
{
    if ($cache == NULL)
        return -1;
    return $cache;
}

/*
 * Overi dostupnost objektu verejnosti.
 * -- ip neni nastavena (pristup povolen pro vsechny ip
 * -- anonym muze cist
 */
function is_accessible($coll, $folder, $photo)
{
    global $rights_cache, $anon_rights_cache, $anonym, $log_user, $READ_RIGHT;
		
		$anon_rights_cache->load($anonym);


    /*
     * kontrola nastaveni pristupu
     */
    $ret = -1;
    if ($photo) {
		$ret = check_cache($anon_rights_cache->order_pht["$photo"]);
	}
	if (($ret == -1) && $folder) {
		$ret = check_cache($anon_rights_cache->order_fld["$folder"]);
	}
	if (($ret == -1) && $coll) {
		$ret = check_cache($anon_rights_cache->order_cll["$coll"]);
	}

    /*
     * jestli blokujeme pristup vsem, krome vybranych ip
     */
    if ($ret == 1) return false;

	/*
	 * proverime prava anonyma
	 */
	if ($anon_rights_cache->check($coll, $folder, $photo, $READ_RIGHT) >= 0)
		$ret = true;
    else
        $ret = false;

    return $ret;
}


/*
 * vrati podle pristupnosti pro verejnost retezec
 */
function accessibility($coll, $folder, $photo)
{
    $pristup = (is_accessible($coll, $folder, $photo)) ? 'veejn' : 'omezen';

    return $pristup;
}

?>
