<?php
/*
 * Konverze metadata Galerie umeleckych del na schemata
 */

require_once "../functions.php";
require_once "../pconnect_db.php3";
require_once "../lib/schema.php";
require_once "../lib/metadata.php";
require_once "../export_xml.php";



$schema_name = "Umleck dla";
$schema_description = "Schma pouivan Rektortem MU pro popis umleckch sbrek.";

$collection_name = "Galerie umleckch dl";
$coll = 25;

$properties = array(
    "artwork"       => array("prefix" => "010", "typ" => "text",     "repeatable" => 0, "mandatory" => 0),
    "artist"      => array("prefix" => "020", "typ" => "text",     "repeatable" => 1, "mandatory" => 0),
    "artist-description" => array("prefix" => "021", "typ" => "textarea", "repeatable" => 1, "mandatory" => 0),
    "medium"      => array("prefix" => "030", "typ" => "text",     "repeatable" => 0, "mandatory" => 0),
    "dimension"   => array("prefix" => "035", "typ" => "text",     "repeatable" => 0, "mandatory" => 0),
    "description" => array("prefix" => "040", "typ" => "textarea", "repeatable" => 1, "mandatory" => 0),
    "type"        => array("prefix" => "050", "typ" => "text",     "repeatable" => 0, "mandatory" => 0),
    "date"        => array("prefix" => "060", "typ" => "text",     "repeatable" => 0, "mandatory" => 0),
    "published"   => array("prefix" => "070", "typ" => "text",     "repeatable" => 0, "mandatory" => 0),
    "remark"      => array("prefix" => "080", "typ" => "text",     "repeatable" => 0, "mandatory" => 0),
);

$property_titles = array(
    "artwork"       => array("cs" => "Dlo",     "en" => "Artwork"),
    "artist"      => array("cs" => "Autor",     "en" => "Artist"),
    "artist-description" => array("cs" => "O autorovi",     "en" => "About Artist"),
    "medium"      => array("cs" => "Medium",      "en" => "Medium"),
    "dimension"   => array("cs" => "Rozmr",    "en" => "Dimension"),
    "description" => array("cs" => "Popis",     "en" => "Description"),
    "type"        => array("cs" => "Typ",       "en" => "Type"),
    "date"        => array("cs" => "Datum",     "en" => "Date"),
    "published"   => array("cs" => "Publikoval", "en" => "Published"),
    "remark"      => array("cs" => "Poznmka",  "en" => "Remark"),
);



/*
 * Prida pole ke schematu. Pole, ktere jeste neni zaregistrovane,
 * zaregistruje.
 */
function schema_add_property($schema, $property, $titles)
{
    $mreg = meta_get_full_register();
    $name = $property["name"];

    // pokud takove pole jeste neni zaregistrovane
    if (! $mreg[$property[name]]) {
        // zaregistruj vsechny jazyky
        foreach($titles[$name] as $lang => $title) {
            meta_register_new($name, $lang, $title);
        }
    }

    return $schema->add_property($property);
}



/*
 * Vytvori schema a prida potrebna pale
 */
function create_schema($name, $description, $properties=array(), $titles=array())
{
    $schema = new Schema();
    $schema->name = $name;
    $schema->description = $description;
    $schema->save();

    foreach($properties as $name => $property) {
        $property["name"] = $name;
        schema_add_property($schema, $property, $titles);
    }

    return $schema;
}



/*
 * Vytvori nebo nacte schema
 */
function create_or_load($name, $description=NULL, $properties=NULL, $titles=NULL)
{
    $schema = Schema::load_schema($name);
    if (! $schema) {
        $schema = create_schema($name, $description, $properties, $titles);
    }

    return $schema;
}



function load_folder($fold) {

    return $folder;
}



function load_collection($coll)
{
    $collection = & new foldTree('collection', $coll);
    $query = "SELECT id FROM folders, collection_folder WHERE collection_folder.id_collection=$coll AND collection_folder.id_folder=folders.id";
    $result = mysql_query($query);
    while ($f = mysql_fetch_object($result)) {
        $folder = & new foldTree('folder', $f->id);
        $collection->add(&$folder);

        $query2 = "SELECT id FROM photos, folder_photo WHERE folder_photo.id_folder=$f->id AND folder_photo.id_photo=photos.id";
        $result2 = mysql_query($query2);
        while ($p = mysql_fetch_object($result2)) {
            $photo = & new foldTree("photo", $p->id);
            $folder->add(&$photo);
        }
    }
    $collection->update();

    return $collection;
}



function set_meta_reg($coll, $folder, $photo, $tag, $text, $name, $lang, $schema) {
    preg_match("!<$tag>([^<]*)</$tag>!", $text, $matches);
    $value = $matches[1];
    meta_set_metadata($coll, $folder, $photo, $name, $lang, $value, $schema);
}

function drop_table($table, $conn, $obj)
{
    $query = "SELECT * FROM $conn WHERE id_$obj->_table='$obj->id'";
    $result = mysql_query($query);
    if (! $result) die($query);

    while ($cov = mysql_fetch_object($result)) {
        $qc = "DELETE FROM $table WHERE id='$cov->id'";
        $res = mysql_query($qc);
        if (! $res) die($qc);
    }

    $query = "DELETE FROM $conn WHERE id_$obj->_table='$obj->id'";
    $result = mysql_query($query);
    if (! $result) die($query);
}


function clean_photo($photo)
{
    $query = "UPDATE photos SET description='', publisher='' WHERE id='$photo->id'";
    $result = mysql_query($query);
    if (! $result) die($query);

    $query = "DELETE FROM photo_note WHERE id_photo='$photo->id'";
    $result = mysql_query($query);
    if (! $result) die($query);

    drop_table("coverage", "coverage_photo", $photo);
    drop_table("source", "photo_source", $photo);
}


/*
 * Konverze kolece podle schematu
 */
function convert_collection($galerie, $schema)
{
    foreach($galerie->childern as $key => $folder) {
            echo $folder->id;
            echo "\n";

        foreach($folder->childern as $key2 => $photo) {
            meta_set_metadata($galerie->id, $folder->id, $photo->id, 'published', 'cs', $photo->publisher, $schema);

            meta_set_metadata($galerie->id, $folder->id, $photo->id, 'remark', 'cs', $photo->notes[0], $schema);

            $source = $photo->sources[0];
            meta_set_metadata($galerie->id, $folder->id, $photo->id, 'type', 'cs', $source->typ, $schema);
            meta_set_metadata($galerie->id, $folder->id, $photo->id, 'date', 'cs', $source->created, $schema);

            set_meta_reg($galerie->id, $folder->id, $photo->id, 'nazev', $photo->description, 'title', 'cs', $schema);
            set_meta_reg($galerie->id, $folder->id, $photo->id, 'autor', $photo->description, 'artist', 'cs', $schema);
            set_meta_reg($galerie->id, $folder->id, $photo->id, 'autor-popis', $photo->description, 'artist-description', 'cs', $schema);
            set_meta_reg($galerie->id, $folder->id, $photo->id, 'dilo', $photo->description, 'medium', 'cs', $schema);
            set_meta_reg($galerie->id, $folder->id, $photo->id, 'dim', $photo->description, 'dimension', 'cs', $schema);

            clean_photo($photo);
        }
    }
}



/*
 * Konverze
 */

// vytvoreni nebo nacteni schematu
$schema = create_or_load($schema_name, $schema_description, $properties, $property_titles);
$galerie = load_collection($coll);

convert_collection($galerie, $schema);

?>
